package gui;

import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JTextField;
import javax.swing.JLabel;
import javax.swing.SpinnerNumberModel;

import java.awt.Color;
import java.awt.Menu;
import java.awt.Window;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;

import javax.swing.JComboBox;
import javax.swing.JSpinner;
import javax.swing.JButton;

import classes.WizardData;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class GUI_CreateScore  {

	private JFrame frame;

	//Atributos
	private JLabel lblAutor;
	private JTextField tf_composer;
	private JLabel lblTitulo;
	private JTextField tf_title;
	
	private JLabel lblInstrumento;
	private JComboBox<String> instrumento;
	private JLabel lblTempo;
	private JSpinner sp_tempo;
	private SpinnerNumberModel sp_tempo_model;
	
	private JLabel lblClave;
	private JComboBox<String> cb_clef;
	private JLabel lblArmadura;
	private JComboBox<String> cb_keySignature;
	private JLabel lblModo;
	private JComboBox<String> cb_keyQuality; 
	private JLabel lblIntensidad;
	private JComboBox<String> cb_dynamic;
	private JLabel lblComps_1;
	private JComboBox<String> cb_numerator;
	private JComboBox<String> cb_denominator;
	private JLabel lbldenominador;

	private JLabel lblNota;
	private JComboBox<String> nota;
	private JLabel lblTipoNota;
	private JComboBox<String> tipoNota;
	
	private JButton btnBack;
	private JButton btnOk;
	
	private WizardData wd = new WizardData();
	
	//Métodos
	public void setFrame(JFrame frame) {
		this.frame = frame;
	}

	/**
	 * Launch the application.
	 */

	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					GUI_CreateScore window = new GUI_CreateScore();
					window.frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public GUI_CreateScore() {
		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {

		//Ponerle el color al fondo
		frame = new JFrame();
		frame.setSize(500, 500);
		frame.setForeground(Color.CYAN);
		frame.getContentPane().setBackground(Color.GRAY);
		frame.getContentPane().setForeground(Color.BLACK);
		//frame.setBounds(100, 100, 513, 428);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.getContentPane().setLayout(null);

		//Creamos los elementos de la interfaz (jTextField, ComboBox...)
		lblAutor = new JLabel("Autor");
		lblAutor.setBounds(17, 45, 70, 15);
		frame.getContentPane().add(lblAutor);
		
		tf_composer = new JTextField();
		tf_composer.setBounds(120, 43, 114, 19);
		frame.getContentPane().add(tf_composer);
		tf_composer.setColumns(10);
		
		lblTitulo = new JLabel("Título");
		lblTitulo.setBounds(17, 89, 70, 15);
		frame.getContentPane().add(lblTitulo);
		
		tf_title = new JTextField();
		tf_title.setBounds(120, 87, 114, 19);
		frame.getContentPane().add(tf_title);
		tf_title.setColumns(10);
		
		lblInstrumento = new JLabel("Instrumento");
		lblInstrumento.setBounds(17, 171, 104, 15);
		frame.getContentPane().add(lblInstrumento);
		
		instrumento = new JComboBox<String>();
		instrumento.setBounds(17, 202, 114, 24);
		frame.getContentPane().add(instrumento);
		instrumento.addItem("Violin");
		instrumento.addItem("Acordeon");
		instrumento.addItem("Piano");
		instrumento.addItem("Guitarra");
		instrumento.addItem("Flauta");
		
		lblTempo = new JLabel("Tempo");
		lblTempo.setBounds(149, 171, 70, 15);
		frame.getContentPane().add(lblTempo);
		
		sp_tempo_model = new SpinnerNumberModel(120, 32, 280, 1);
		sp_tempo = new JSpinner(sp_tempo_model);
		sp_tempo.setBounds(159, 205, 44, 20);
		frame.getContentPane().add(sp_tempo);

		lblClave = new JLabel("Clave");
		lblClave.setBounds(17, 254, 56, 15);
		frame.getContentPane().add(lblClave);
		
		cb_clef = new JComboBox<String>();
		cb_clef.setBounds(17, 281, 56, 24);
		frame.getContentPane().add(cb_clef);
		cb_clef.addItem("FA");
		cb_clef.addItem("SOL");
		cb_clef.setSelectedItem("SOL");

		lblArmadura = new JLabel("Armadura");
		lblArmadura.setBounds(91, 254, 70, 15);
		frame.getContentPane().add(lblArmadura);
		
		cb_keySignature = new JComboBox<String>();
		cb_keySignature.setBounds(91, 281, 56, 24);
		frame.getContentPane().add(cb_keySignature);
		cb_keySignature.addItem("7#");
		cb_keySignature.addItem("6#");
		cb_keySignature.addItem("5#");
		cb_keySignature.addItem("4#");
		cb_keySignature.addItem("3#");
		cb_keySignature.addItem("2#");
		cb_keySignature.addItem("1#");
		cb_keySignature.addItem("0");
		cb_keySignature.addItem("1b");
		cb_keySignature.addItem("2b");
		cb_keySignature.addItem("3b");
		cb_keySignature.addItem("4b");
		cb_keySignature.addItem("5b");
		cb_keySignature.addItem("6b");
		cb_keySignature.addItem("7b");
		cb_keySignature.setSelectedItem("0");
		
		lblModo = new JLabel("Modo");
		lblModo.setBounds(184, 254, 70, 15);
		frame.getContentPane().add(lblModo);
		
		cb_keyQuality = new JComboBox<String>();
		cb_keyQuality.setBounds(184, 281, 70, 24);
		frame.getContentPane().add(cb_keyQuality);
		cb_keyQuality.addItem("Mayor");
		cb_keyQuality.addItem("menor");
		
		lblIntensidad = new JLabel("Intensidad");
		lblIntensidad.setBounds(266, 254, 87, 15);
		frame.getContentPane().add(lblIntensidad);
		
		cb_dynamic = new JComboBox<String>();
		cb_dynamic.setBounds(266, 281, 70, 24);
		frame.getContentPane().add(cb_dynamic);
		cb_dynamic.addItem("Silent");
		cb_dynamic.addItem("PPP");
		cb_dynamic.addItem("PP");
		cb_dynamic.addItem("P");
		cb_dynamic.addItem("MP");
		cb_dynamic.addItem("MF");
		cb_dynamic.addItem("F");
		cb_dynamic.addItem("FF");
		cb_dynamic.addItem("FFF");
		cb_dynamic.setSelectedItem("P");
		
		lblComps_1 = new JLabel("Compás");
		lblComps_1.setBounds(376, 222, 70, 15);
		frame.getContentPane().add(lblComps_1);
		
		cb_numerator = new JComboBox<String>();
		cb_numerator.setBounds(371, 249, 56, 24);
		frame.getContentPane().add(cb_numerator);
		cb_numerator.addItem("1");
		cb_numerator.addItem("2");
		cb_numerator.addItem("3");
		cb_numerator.addItem("4");
		cb_numerator.addItem("5");
		cb_numerator.addItem("6");
		cb_numerator.addItem("7");
		cb_numerator.addItem("8");
		cb_numerator.addItem("9");
		cb_numerator.setSelectedItem("4");
		
//		cb_denominator = new JComboBox<String>();
//		cb_denominator.setBounds(371, 281, 55, 24);
//		frame.getContentPane().add(cb_denominator);
//		cb_denominator.addItem("1");
//		cb_denominator.addItem("2");
//		cb_denominator.addItem("4");
//		cb_denominator.addItem("8");
//		cb_denominator.addItem("16");
//		cb_denominator.addItem("32");
//		cb_denominator.addItem("64");
//		cb_denominator.setSelectedItem("4");
		lbldenominador = new JLabel("4");
		lbldenominador.setBounds(371, 281, 55, 24);
		frame.getContentPane().add(lbldenominador);
		
		
		lblNota = new JLabel("Altura nota");
		lblNota.setBounds(366, 58, 80, 15);
		frame.getContentPane().add(lblNota);
		
		nota = new JComboBox<String>();
		nota.setBounds(366, 84, 111, 24);
		frame.getContentPane().add(nota);
		nota.addItem("Do");
		nota.addItem("Re");
		nota.addItem("Mi");
		nota.addItem("Fa");
		nota.addItem("Sol");
		nota.addItem("La");
		nota.addItem("Si");

		lblTipoNota = new JLabel("Duración nota");
		lblTipoNota.setBounds(366, 157, 100, 15);
		frame.getContentPane().add(lblTipoNota);
		
		tipoNota = new JComboBox<String>();
		tipoNota.setBounds(366, 184, 111, 24);
		frame.getContentPane().add(tipoNota);
		tipoNota.addItem("Corchea");
		tipoNota.addItem("Negra");
		tipoNota.addItem("Negra puntillo");
		tipoNota.addItem("Blanca");
		tipoNota.addItem("Blanca puntillo");
		tipoNota.addItem("Redonda");

		btnBack = new JButton("Atrás");
		btnBack.setBounds(272, 337, 82, 25);
		frame.getContentPane().add(btnBack);
		btnBack.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {

				GUI_Welcome W= new GUI_Welcome();
				W.getFrame().setVisible(true);
				frame.setVisible(false);	

			}
		});
		
		btnOk = new JButton("Aceptar");
		btnOk.setBounds(366, 337, 100, 25);
		frame.getContentPane().add(btnOk);
		
		btnOk.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {				
				takeValues();

				new Notate(wd);
				
				frame.setVisible(false);
			}
		});
		
	}
			
	public void takeValues(){		

		wd.setComposer(tf_composer.getText());
		wd.setTitle(tf_title.getText());
		wd.setTempo(sp_tempo.getValue().toString());
		wd.setClef(cb_clef.getSelectedItem().toString());
		wd.setKeySignature(cb_keySignature.getSelectedItem().toString());
		wd.setKeyQuality(cb_keyQuality.getSelectedItem().toString());
		wd.setDynamic(cb_dynamic.getSelectedItem().toString());
		wd.setNumerator(cb_numerator.getSelectedItem().toString());
		//wd.setDenominator(cb_denominator.getSelectedItem().toString());
		wd.setInstrument(instrumento.getSelectedItem().toString());
		wd.setNote(nota.getSelectedItem().toString());
		wd.setNoteType(tipoNota.getSelectedItem().toString());
		
	}

	public Window getFrame() {
		// TODO Auto-generated method stub
		return frame;
	}
}
