package gui;


import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileFilter;
import javax.xml.stream.XMLStreamException;

import classes.ScoreInformation;
import classes.WizardData;
import exceptions.StAXParsingError;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.filechooser.FileView;

import java.awt.Color;
import java.awt.event.MouseEvent;
import java.io.File;
import java.io.FileNotFoundException;
import java.awt.event.MouseAdapter;
import java.awt.Toolkit;

@SuppressWarnings("serial")
public class GUI_Welcome extends JFrame{

	private JFrame frame;
	final JFileChooser fc = new JFileChooser();
	ScoreInformation si = ScoreInformation.getSI();

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					GUI_Welcome window = new GUI_Welcome();
					window.getFrame().setVisible(true);
					
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public GUI_Welcome() {
		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {

		frame = new JFrame();
		frame.setSize(500, 500);
		

		frame.getContentPane().setBackground(Color.BLACK);
		frame.getContentPane().setLayout(null);

		JButton btnNewButton = new JButton("Crear Partitura");

		btnNewButton.setForeground(Color.BLACK);
		btnNewButton.setBackground(Color.WHITE);
		btnNewButton.setBounds(171, 122, 147, 25);
		frame.getContentPane().add(btnNewButton);
		btnNewButton.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				GUI_CreateScore window = new GUI_CreateScore();
				window.getFrame().setVisible(true);
				frame.setVisible(false);				
			}
		});

		JButton btnNewButton_1 = new JButton("Abrir Partitura");
		btnNewButton_1.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				
				JFrame alertFrame = new JFrame();
				
				try
				{
					String path = getImpXmlToJmPath();
	
					if (path != null)
					{
						WizardData wd;
						
						si.setPath(path);
						wd = modules.ImpXmlToJm.main();
						frame.setVisible(false);
						new Notate(wd);
					}
					else 
					{
						return;
					}
				}
				catch (FileNotFoundException exc)
	        	{
					exc.printStackTrace();
					JOptionPane.showMessageDialog(alertFrame, "Archivo no encontrado.");
				}
				catch (XMLStreamException exc)
				{
					exc.printStackTrace();
					JOptionPane.showMessageDialog(alertFrame, "Error en el formato del archivo. ¿Es un archivo XML?");
				}
				catch (StAXParsingError exc)
				{
					exc.printStackTrace();
					JOptionPane.showMessageDialog(alertFrame, "Error en la lectura del archivo. ¿Es un archivo de formato MusicXML?");
				}
				/*catch (MusicXMLValidationError exc)
				{
					e.printStackTrace();
					
					JOptionPane.showMessageDialog(alertFrame, exc.getMessage());
				}*/
			}
		});
		btnNewButton_1.setForeground(Color.BLACK);
		btnNewButton_1.setBackground(Color.WHITE);
		btnNewButton_1.setBounds(171, 213, 147, 25);
		frame.getContentPane().add(btnNewButton_1);
	}

	public JFrame getFrame() {
		return frame;
	}

	public void setFrame(JFrame frame) {
		this.frame = frame;
	}
	
	public String getImpXmlToJmPath() {
		String path = new String();

		FileFilter xmlType = new FileNameExtensionFilter("Archivo MusicXML (*.xml)", "xml");
		JFileChooser fc = new JFileChooser();
		fc.addChoosableFileFilter(xmlType);
		fc.setFileFilter(xmlType);

		int returnVal = fc.showOpenDialog(GUI_Welcome.this);

		if (returnVal == JFileChooser.APPROVE_OPTION)
		{
			path = fc.getSelectedFile().getAbsolutePath();
		}
		else if (returnVal == JFileChooser.CANCEL_OPTION)
		{
			path = null;
		}

		return path;
	}
	
}