package modules;

import gui.GUI_CreateScore;

import java.awt.Button;
import java.awt.FileDialog;
import java.awt.Frame;
import java.awt.Label;
import java.awt.TextArea;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import classes.FigureJm;
import classes.ScoreInformation;
import jm.JMC;
import jm.music.data.Note;
import jm.music.data.Part;
import jm.music.data.Phrase;
import jm.music.data.Score;
import jm.util.Write;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;

import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.plaf.basic.BasicSplitPaneUI.KeyboardDownRightHandler;
import javax.xml.stream.XMLEventFactory;
import javax.xml.stream.XMLEventWriter;
import javax.xml.stream.XMLOutputFactory;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.XMLStreamWriter;
import javax.xml.stream.events.Characters;
import javax.xml.stream.events.EndElement;
import javax.xml.stream.events.StartDocument;
import javax.xml.stream.events.StartElement;
import javax.xml.stream.events.XMLEvent;

import com.sun.xml.internal.txw2.output.IndentingXMLStreamWriter;

public class ExpJmToXml extends Frame implements 
ActionListener, 
WindowListener, JMC {
	//

	static ScoreInformation si = ScoreInformation.getSI();
	static Score score = si.getScore();
	//GUI_CreateScore cs = new GUI_CreateScore();
	//Part part = new Part();
	//Note n = new Note();
	//Phrase phrase = new Phrase();
	static Scanner keyboard;
	static File file;
	static int measureNumber=1;
	static String partId = "P1";

	static XMLOutputFactory factory = XMLOutputFactory.newInstance();
	static XMLStreamWriter writer; 



	//Aqui se dice donde quiere guardar el xml
	public static void main() {
		System.out.println(score);
		Part part = score.getPart(0);
		Phrase phrase = part.getPhrase(0);

		file = new File(si.getPath());

		// keyboard= new Scanner(System.in);
		// path= keyboard.nextLine();
		// getPath();

		// Ventana para guardad el xml

		// System.out.println("Escribe el nombre del archivo a guardar:");

		try {
			writer = new IndentingXMLStreamWriter(factory.createXMLStreamWriter(new FileOutputStream(file), "UTF-8"));

			expHeaderToXML();
			expMeasureAttributesToXML();
			expFiguresToXML(phrase);
			expEndingToXML();
			JFrame frame = new JFrame();
			JOptionPane.showMessageDialog(frame, "El archivo se ha exportado correctamente.");

			writer.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (XMLStreamException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	

	public static void expHeaderToXML() throws XMLStreamException{
		try {
			//<?xml version="1.0" encoding="utf-8"?>
			writer.writeStartDocument("utf-8", "1.0");
			
			
			//TODO add <!DOCTYPE
			writer.writeDTD("<!DOCTYPE score-partwise PUBLIC \"-//Recordare//DTD MusicXML 3.0 Partwise//EN\" \"http://www.musicxml.org/dtds/partwise.dtd\">");
			writer.writeCharacters("\n");
			
				//<score-partwise version="3.0">
				writer.writeStartElement("score-partwise");
				writer.writeAttribute("version", "3.0");
				
					//<work>
					writer.writeStartElement("work");
						 
						//<work-title>
						writer.writeStartElement("work-title");
						writer.writeCharacters(score.getTitle());
						
						//</work-title>
						writer.writeEndElement();
					
					//</work>
					writer.writeEndElement();
						
					//<identification>
					writer.writeStartElement("identification");
						
						//<creator>
						writer.writeStartElement("creator");
						writer.writeAttribute("type", "composer");
						writer.writeCharacters(si.getComposer());
						
						//</creator>
				
						writer.writeEndElement();
						
						//<encoding>
						writer.writeStartElement("encoding");
						//<software>
						writer.writeStartElement("software");
						writer.writeCharacters("KOSMOS");
						//</software>
						writer.writeEndElement();
			
						//</encoding>
						writer.writeEndElement();
						
					//<</identification>
					writer.writeEndElement();

	
					//<part-list>
					writer.writeStartElement("part-list");
	
						//<score-part id="P1">
						writer.writeStartElement("score-part");
						writer.writeAttribute("id", partId);
						
						//Part-name
						writer.writeStartElement("part-name");
						writer.writeCharacters("Music");
						//</part-name>
						writer.writeEndElement();
						
						//</score-part>
						writer.writeEndElement();
											
					//</part-list>
					writer.writeEndElement();

			writer.flush();

		} catch (XMLStreamException e) {
			e.printStackTrace();
		}

	}


	public static void expMeasureAttributesToXML() throws XMLStreamException{
		//<part id="P1">
		writer.writeStartElement("part");
		writer.writeAttribute("id", partId);
		
		//<measure number>
		writer.writeStartElement("measure");
		writer.writeAttribute("number",  Integer.toString(measureNumber));
		
		//<attributes>
		writer.writeStartElement("attributes");
		
		//<divisions>
			writer.writeStartElement("divisions");
			writer.writeCharacters(Integer.toString(si.getDivisions()));
		//</divisions>
			writer.writeEndElement();
		
		//<key>
		writer.writeStartElement("key");
			//<fifths>
			writer.writeStartElement("fifths");
			writer.writeCharacters(Integer.toString(score.getKeySignature()));
			//</fifths>
			writer.writeEndElement();
			
			//<mode>
			writer.writeStartElement("mode");
			if (score.getKeyQuality() == 0) {
				writer.writeCharacters("major");
			}
			else if (score.getKeyQuality() == 1) {
				writer.writeCharacters("minor");
			}
			
			//</mode>
			writer.writeEndElement();
		//</key>
		writer.writeEndElement();
		
		//<time>
		writer.writeStartElement("time");
			//<beats>
			writer.writeStartElement("beats");
			writer.writeCharacters(Integer.toString(score.getNumerator()));
			//</beats>
			writer.writeEndElement();
			
			//<beat-type>
			writer.writeStartElement("beat-type");
			writer.writeCharacters(Integer.toString(score.getDenominator()));
			//</beat-type>
			writer.writeEndElement();
		//</time>
		writer.writeEndElement();
		

		//<clef>
		writer.writeStartElement("clef");
		
		 if (si.getClef()=="SOL"){
		
			//<sign>
			writer.writeStartElement("sign");
			writer.writeCharacters("G");
			//</sign>
			writer.writeEndElement();
			
			//<line>
			writer.writeStartElement("line");
			writer.writeCharacters(Integer.toString(2));
			//</line>
			writer.writeEndElement();}
		 
		 else if (si.getClef()=="FA") {
			//<sign>
			writer.writeStartElement("sign");
			writer.writeCharacters("F");
			//</sign>
			writer.writeEndElement();
			
			//<line>
			writer.writeStartElement("line");
			writer.writeCharacters(Integer.toString(4));
			//</line>
			writer.writeEndElement();
		 }
		 
		//</clef>
		writer.writeEndElement();

	//</attributes>
	writer.writeEndElement();
	
	//<direction placement="above">
	writer.writeStartElement("direction");
	writer.writeAttribute("placement", "above");
		//<direction-type>
		writer.writeStartElement("direction-type");
			//<metronome parentheses="no">
			writer.writeStartElement("metronome");
			writer.writeAttribute("parentheses", "no");
				//<beat-unit>quarter</beat-unit>
			writer.writeStartElement("beat-unit");
			writer.writeCharacters("quarter");
			writer.writeEndElement();
				//<per-minute>80</per-minute>
			writer.writeStartElement("per-minute");
			Double tempo = score.getTempo();
			writer.writeCharacters(String.valueOf(tempo.intValue()));
			writer.writeEndElement();
			//</metronome>
			writer.writeEndElement();
		//</direction-type>
		writer.writeEndElement();
		//<sound tempo="80"/>
		writer.writeEmptyElement("sound");
		writer.writeAttribute("tempo", String.valueOf(tempo.intValue()));
	//</direction>
	writer.writeEndElement();
		

	}


	public static void expFiguresToXML(Phrase phrase) throws XMLStreamException{
		 Note[] noteArray = phrase.getNoteArray();
		 FigureJm jm;
		 int cont= 0;
		 int maxDiv= score.getNumerator() * si.getDivisions();
		 int collDiv=0;
		 int remDur = 0; //remaining Duration
		 int divDur = 0; //divided Duration		

		 while (noteArray.length >cont){
			 
			Note n= noteArray[cont];
			jm = convJmToXml(n);
			remDur = calculateDivDur(n.getRhythmValue(), si.getDivisions());
			
			while (remDur!=0)
			{
				if (collDiv==0 && jm.isTieStart()){
					jm.setTieStop(true);
					jm.setTieStart(false);
				}
				
				if ((collDiv + remDur)>maxDiv)
				{
					divDur = maxDiv-collDiv;
				} else
				{
					divDur = remDur;
				}
				
				// Updates the duration if the figure is in the process of being divided
				updateDuration(jm, (double) divDur, si.getDivisions());
				
				collDiv = collDiv + divDur;
				
				if (collDiv >= maxDiv)
				{
					if (collDiv == maxDiv && !jm.isRest() && !(remDur==divDur))
					{
						jm.setTieStart(true);
					}
					
					printFigureTags(jm);
					printNewMeasure();
					
					collDiv=0;
				} else
				{
					printFigureTags(jm);
				}
				
				remDur = remDur - divDur;
				
			}
			
			cont++;

		 }

	}

	private static void updateDuration(FigureJm jm, Double divDur, int divisions)
	{
		jm.setDividedDuration(divDur.intValue());
		
		// Convert divided duration of the new figure to rhythmValue
		Double rhythmValue = ddToRv(divisions, divDur);
		String duration = noteDuration(rhythmValue);
			
		if (duration!=null){
			jm.setDot(false);
			jm.setType(duration);
		}
		else {
			jm.setDot(true);
			rhythmValue = rhythmValue * 2/3; //we delete the dot's value
			jm.setType(noteDuration(rhythmValue));
		}
		
	}

	private static Double ddToRv(int divisions, Double divDur) {
		return divDur/divisions;
	}

	public static void expEndingToXML(){

		try {
				//</score-partwise>
				writer.writeEndElement();
				
			//
			writer.writeEndDocument();
			
			writer.flush();
			writer.close();
		} catch (XMLStreamException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	public static void printNewMeasure() throws XMLStreamException {
		 //</measure>
		writer.writeEndElement();

		measureNumber++;

		//<measure number>
		writer.writeStartElement("measure");
		writer.writeAttribute("number",  Integer.toString(measureNumber));
	}

	public static void printFigureTags(FigureJm jm) throws XMLStreamException {
		
		//<note>
		writer.writeStartElement("note");
		
			if (jm.isRest()==true){
			//</rest>
			writer.writeEmptyElement("rest");
			} else {
			//<pitch>
			writer.writeStartElement("pitch");
		
				//<step>
				writer.writeStartElement("step");
				writer.writeCharacters(jm.getStep());
				//</step>
				writer.writeEndElement();
				
				if (!jm.getAlter().equals("0")) {
				//<alter>
				writer.writeStartElement("alter");
				writer.writeCharacters(jm.getAlter());
				//</alter>
				writer.writeEndElement();
				}

				//<octave>
				writer.writeStartElement("octave");
				writer.writeCharacters(jm.getOctave());
				//</octave>
				writer.writeEndElement();
				
			//</pitch>
			writer.writeEndElement();
			}
			
		//<duration>
		writer.writeStartElement("duration");
		
			writer.writeCharacters(Integer.toString(jm.getDividedDuration()));
	
		//</duration>
		writer.writeEndElement();
		
		//</tieStop>
		if (jm.isTieStop()){
			// tie
			writer.writeEmptyElement("tie");
			writer.writeAttribute("type","stop");
		}
		
		//</tieStart>
		if (jm.isTieStart()){
			writer.writeEmptyElement("tie");
			writer.writeAttribute("type","start");
		}
		
		//<type>
		writer.writeStartElement("type");
		writer.writeCharacters(jm.getType());
		//</type>
		writer.writeEndElement();
		
		//</dot>
		if (jm.isDot()==true){
			writer.writeEmptyElement("dot");
		}
		
		// tied notations
		if (jm.isTieStart() || jm.isTieStop())
		{
			// <notations>
			writer.writeStartElement("notations");
			
			if (jm.isTieStop())
			{
				//<tied type="stop"/>
				writer.writeEmptyElement("tied");
				writer.writeAttribute("type","stop");
			}
			if (jm.isTieStart())
			{
				//<tied type="start"/>
				writer.writeEmptyElement("tied");
				writer.writeAttribute("type","start");
			}
			// </notations>
			writer.writeEndElement();
		}
		
	//</note>
	writer.writeEndElement();

	}
	
	public static FigureJm convJmToXml(Note n){
		FigureJm jm = new FigureJm();
		System.out.println(n.getNote());

		jm.setPitch(n.getPitch());
		jm.setRhythmValue(n.getRhythmValue());
		String note = n.getNote();
		if (note.length() == 1) {
			// If the note is natural, its name will only have 1 character
			jm.setStep(n.getNote());
			jm.setAlter("0");
		} else if (note.length() == 2) {
			// If the note is not natural, the first character will be "step",
			// and the second one "alter"
			jm.setStep(note.substring(0, 1));
			String alter = note.substring(1, 2);
			if (alter.equals("b") || alter.equals("B")) {
				jm.setAlter("-1");
			} else if (alter.equals("#")) {
				jm.setAlter("1");
			}
		}
		int pitch = n.getPitch();
		pitch = pitch / 12;
		pitch = pitch - 1;
		jm.setOctave(Integer.toString(pitch));

		int dd = calculateDivDur(jm.getRhythmValue(), si.getDivisions());
		jm.setDividedDuration(dd);

		Double rhythmValue = n.getRhythmValue();
		String duration = noteDuration(rhythmValue);

		if (duration != null) {
			jm.setDot(false);
			jm.setType(duration);

		} else {
			jm.setDot(true);
			rhythmValue = rhythmValue * 2 / 3; // we delete the dot's value
			jm.setType(noteDuration(rhythmValue));
		}

		/*if (n.isFlat()) {
			jm.getAccidental();
		} else if (n.isNatural()) {

		} else if (n.isSharp()) {

		} else {

		}*/

		if (n.isRest() == true) {
			jm.setRest(true);
		} else {
			jm.setRest(false);
		}

		return jm;
		
	}
	
	
	private static int calculateDivDur(double rhythmValue, int divisions) {
		return (int) (rhythmValue * divisions);
	}

	public static String noteDuration(Double rhythmValue){
		
		String duration = null;
		if (rhythmValue==0.25)
	 	{
			duration= "16th";
	 	}
		else if (rhythmValue==0.5)
	 	{
			duration= "eighth";
	 	}
	 	else if (rhythmValue==1.0)
	 	{
			duration= "quarter";
	 	}
	 	else if (rhythmValue==2.0)
	 	{
			duration= "half";
	 	}
	 	else if (rhythmValue==4.0)
	 	{
			duration= "whole";
	 	}
		return duration;
	 	
		
	}
	
	
	
	
	

	@Override
	public void windowActivated(WindowEvent arg0) {
		// TODO Auto-generated method stub

	}


	@Override
	public void windowClosed(WindowEvent arg0) {
		// TODO Auto-generated method stub

	}


	@Override
	public void windowClosing(WindowEvent arg0) {
		// TODO Auto-generated method stub

	}


	@Override
	public void windowDeactivated(WindowEvent arg0) {
		// TODO Auto-generated method stub

	}


	@Override
	public void windowDeiconified(WindowEvent arg0) {
		// TODO Auto-generated method stub

	}


	@Override
	public void windowIconified(WindowEvent arg0) {
		// TODO Auto-generated method stub

	}


	@Override
	public void windowOpened(WindowEvent arg0) {
		// TODO Auto-generated method stub

	}


	@Override
	public void actionPerformed(ActionEvent arg0) {
		// TODO Auto-generated method stub

	}


	
	
	
	
	
	
	
	
	
	
	
}
